/* --- Copyright University of Sussex 2000. All rights reserved. ----------
 > File:            C.unix/pop/popenv.p
 > Purpose:         Set environment variables, and run saved image if needed
 > Author:          Aaron Sloman, University of Birmingham 26 Mar 2000
 > Documentation:   REF SYSTEM
 > Related Files:   C.unix/pop/init.p
 */

;;; doesn't handle $popcomppath or $popsavepath yet

lconstant
		Sysdir = systranslate('popsys'),
		sysdir = Sysdir or allbutlast(1, sys_fname_path(popfilename)),
		;;; Superdirectory is $usepop/pop
		popdir = allbutlast(1, sys_fname_path(sysdir)),
		;;; Superdirectory is $usepop
		usepop = allbutlast(1, sys_fname_path(popdir)),
		exlinkbase = sysdir >< '/basepop11.stb',
		externlib = popdir >< '/extern/lib',
	 ;

define global sys_file_exists(file);
	;;; can't autoload, so do this now.
	sys_file_stat(file, {})
enddefine;

conspair('usepop=' >< usepop, popenvlist) -> popenvlist;

if sys_file_exists(exlinkbase) then
	conspair(('popexlinkbase=' >< exlinkbase), popenvlist) -> popenvlist;
endif;

;;; Sort out LD_LIBRARY_PATH See $popcom/popenv

define lconstant SetLdPath(lib_var);
	;;; Set path for shared libraries
	lvars lib_path = systranslate(lib_var);
	if lib_path then
		unless issubstring(externlib, lib_path ) then
			false  -> systranslate(lib_var);
			lib_path >< ':' >< externlib -> systranslate(lib_var)
		endunless
	else
		externlib -> systranslate(lib_var)
	endif;
	;;; [^lib_var ^(systranslate(lib_var))] ==>
enddefine;

;;; Now set it
if hd(sys_os_type) == "unix" then
	lvars
		type = back(sys_os_type),
		os = front(type),
		version = front(back(type));

	if  os == "sunos" and version >= 5.0
	or  os == "unix" and version >= 4.0
	or	os == "unix_sv"
		or os == "osf1"
	then
		SetLdPath('LD_LIBRARY_PATH');
	elseif os == "hpux" then
		SetLdPath('SHLIB_PATH');
	endif;
endif;

;;; Some of these items are needed only for system developers
;;; So they should be optional extras
lvars envlist =
	[%
	;;; Assume this one is already set as an environment variable
	;;; 'popsys=' >< usepop >< '/pop/pop',
	'popcom=' >< usepop >< '/pop/com',
	'popexternlib=' >< usepop >< '/pop/extern/lib',
	'popsrc=' >< usepop >< '/pop/src',
	'popautolib=' >< usepop >< '/pop/lib/auto',
	'popdatalib=' >< usepop >< '/pop/lib/data',
	'popliblib=' >< usepop >< '/pop/lib/lib',
	'poppwmlib=' >< usepop >< '/pop/lib/pwm',
	'popsunlib=' >< usepop >< '/pop/lib/sun',
	'popvedlib=' >< usepop >< '/pop/lib/ved',
	'poplocal=/bham/common/com/packages/poplog',
	'poplocalauto=/bham/common/com/packages/poplog/local/auto',
	'poplocalbin=' >< usepop >< '/poplocalbin',
	'popobjlib=' >< usepop >< '/pop/obj',
	unless systranslate('poplib') then
		'poplib=' >< sysfileok('~') >< '/Poplib',
	endunless,
	;;; the next one is used to suppress re-reading of this file
    'ARGSDONE=1'
	%];

envlist nc_<> popenvlist -> popenvlist;



;;; Now set information for executables
lconstant
		basepop = sysdir >< '/basepop11',
		;;; for system builders
		corepop = sysdir >< '/corepop',
		psvdir	= '+' >< usepop >< '/pop/lib/psv/',
		pop11	= psvdir >< 'startup.psv',
		prolog	= psvdir >< 'prolog.psv',
	    clisp	= psvdir >< 'clisp.psv',
	    pml		= psvdir >< 'pml.psv',

		runargs =
			['pop11' [^pop11]
			 'ved' [^pop11 ':sysinitcomp();ved']
	    	 'xved' [%pop11, psvdir >< 'xved.psv' %]
			 ;;; 'xved' [^pop11 ':sysinitcomp();"x" -> vedusewindows; ved']
			 'prolog' [^pop11 ^prolog]
			 'clisp' [^pop11 ^clisp ]
			 'pml' [^pop11 ^pml]
			 'help' [^pop11 ':sysinitcomp();help']
			 'teach'  [^pop11 ':sysinitcomp();teach']
			 'eliza'  'lib elizaprog;eliza();'
;;;/* for system builders
			 'popc' ['+$popsys/popc.psv']
			 'poplib' ['+$popsys/poplibr.psv']
			 'poplink' ['+$popsys/poplink.psv']
;;;*/
			],

	;

;;; [foundargs ^foundargs]=>

;;;; [poparglist ^poparglist] =>

if poparg0 = 'basepop11' or poparg0 = basepop
   or isendstring('/basepop11', poparg0)
   or poparg0 = 'corepop'
then
	;;; run as invoked
else
	lvars (runbase, nobanner) =
		if member(poparg0, ['popc' 'poplink' 'poplibr']) then
			corepop, false
		else
			basepop, '%nobanner'
		endif;

	;;; See if poplog was invoked via one of the names in runargs
	lvars
		foundargs = lmember_=(poparg0, runargs);

	if foundargs then
		front(back(foundargs)) -> foundargs;

		if ispair(foundargs) then
			sysexecute(runbase,
				[^runbase ^^foundargs
					^(if nobanner then nobanner endif) ^^poparglist], false)
		else
			;;; treat it as pop11 code in a string
			pop11_compile(pdtolist(incharitem(stringin(foundargs))));
		endif
	else
		mishap('Run with unknown name', [^poparg0])	
	endif
endif;	
